namespace com.progsbase.no.inductive.libraries.MeasurementUnits_v0_1_3{

using static System.Math;

public class BooleanArrayReference{
	public bool [] booleanArray;
}
public class BooleanReference{
	public bool booleanValue;
}
public class CharacterReference{
	public char characterValue;
}
public class NumberArrayReference{
	public double [] numberArray;
}
public class NumberReference{
	public double numberValue;
}
public class StringArrayReference{
	public StringReference [] stringArray;
}
public class StringReference{
	public char [] stringx;
}
public class MeasurementUnits{
	public static double KilometersToMiles(double kilometers){
		return kilometers/1.609344;
	}


	public static double MilesToKilometers(double miles){
		return miles*1.609344;
	}


	public static double NauticalMilesToKilometers(double nm){
		return nm*1.852;
	}


	public static double KilometersTiNauticalMiles(double km){
		return km/1.852;
	}


	public static bool ConvertLength(char [] from, char [] to, double sourceUnits, NumberReference destinationUnits){
		bool success;

		success = ConvertLengthToMeters(from, sourceUnits, destinationUnits);
		if(success){
			success = ConvertLengthFromMeters(to, destinationUnits.numberValue, destinationUnits);
		}

		return success;
	}


	public static bool ConvertLengthFromMeters(char [] from, double m, NumberReference destinationUnits){
		double y;
		bool success;

		success = true;
		y = 0d;
		if(StringsEqual(from, "meter".ToCharArray())){
			y = m;
		}else if(StringsEqual(from, "thou".ToCharArray())){
			y = ConvertMetersToThous(m);
		}else if(StringsEqual(from, "inch".ToCharArray())){
			y = ConvertMetersToInches(m);
		}else if(StringsEqual(from, "foot".ToCharArray())){
			y = ConvertMetersToFeet(m);
		}else if(StringsEqual(from, "yard".ToCharArray())){
			y = ConvertMetersToYards(m);
		}else if(StringsEqual(from, "chain".ToCharArray())){
			y = ConvertMetersToChains(m);
		}else if(StringsEqual(from, "furlong".ToCharArray())){
			y = ConvertMetersToFurlongs(m);
		}else if(StringsEqual(from, "mile".ToCharArray())){
			y = ConvertMetersToMiles(m);
		}else if(StringsEqual(from, "league".ToCharArray())){
			y = ConvertMetersToLeagues(m);
		}else if(StringsEqual(from, "fathom".ToCharArray())){
			y = ConvertMetersToFathoms(m);
		}else if(StringsEqual(from, "cable".ToCharArray())){
			y = ConvertMetersToCables(m);
		}else if(StringsEqual(from, "nautical mile".ToCharArray())){
			y = ConvertMetersToNauticalMiles(m);
		}else if(StringsEqual(from, "link".ToCharArray())){
			y = ConvertMetersToLinks(m);
		}else if(StringsEqual(from, "rod".ToCharArray())){
			y = ConvertMetersToRods(m);
		}else if(StringsEqual(from, "decameter".ToCharArray())){
			y = ConvertMetersToDecaMeters(m);
		}else if(StringsEqual(from, "hectometer".ToCharArray())){
			y = ConvertMetersToHectoMeters(m);
		}else if(StringsEqual(from, "kilometer".ToCharArray())){
			y = ConvertMetersToKiloMeters(m);
		}else if(StringsEqual(from, "megameter".ToCharArray())){
			y = ConvertMetersToMegaMeters(m);
		}else if(StringsEqual(from, "gigameter".ToCharArray())){
			y = ConvertMetersToGigaMeters(m);
		}else if(StringsEqual(from, "terameter".ToCharArray())){
			y = ConvertMetersToTeraMeters(m);
		}else if(StringsEqual(from, "petameter".ToCharArray())){
			y = ConvertMetersToPetaMeters(m);
		}else if(StringsEqual(from, "exameter".ToCharArray())){
			y = ConvertMetersToExaMeters(m);
		}else if(StringsEqual(from, "zettameter".ToCharArray())){
			y = ConvertMetersToZettaMeters(m);
		}else if(StringsEqual(from, "yottameter".ToCharArray())){
			y = ConvertMetersToYottaMeters(m);
		}else if(StringsEqual(from, "light-year".ToCharArray())){
			y = ConvertMetersToLightYears(m);
		}else if(StringsEqual(from, "parsec".ToCharArray())){
			y = ConvertMetersToParsecs(m);
		}else if(StringsEqual(from, "astronomical unit".ToCharArray())){
			y = ConvertMetersToAstronomicalUnits(m);
		}else if(StringsEqual(from, "decimeter".ToCharArray())){
			y = ConvertMetersToDeciMeters(m);
		}else if(StringsEqual(from, "centimeter".ToCharArray())){
			y = ConvertMetersToCentiMeters(m);
		}else if(StringsEqual(from, "millimeter".ToCharArray())){
			y = ConvertMetersToMilliMeters(m);
		}else if(StringsEqual(from, "micrometer".ToCharArray())){
			y = ConvertMetersToMicroMeters(m);
		}else if(StringsEqual(from, "nanometer".ToCharArray())){
			y = ConvertMetersToNanoMeters(m);
		}else if(StringsEqual(from, "picometer".ToCharArray())){
			y = ConvertMetersToPicoMeters(m);
		}else if(StringsEqual(from, "femtometer".ToCharArray())){
			y = ConvertMetersToFemtoMeters(m);
		}else if(StringsEqual(from, "attometer".ToCharArray())){
			y = ConvertMetersToAttoMeters(m);
		}else if(StringsEqual(from, "zeptometer".ToCharArray())){
			y = ConvertMetersToZeptoMeters(m);
		}else if(StringsEqual(from, "yoctometer".ToCharArray())){
			y = ConvertMetersToYoctoMeters(m);
		}else if(StringsEqual(from, "planck length".ToCharArray())){
			y = ConvertMetersToPlanckLengths(m);
		}else{
			success = false;
		}

		destinationUnits.numberValue = y;

		return success;
	}


	public static double ConvertMetersToPlanckLengths(double m){
		return m/1.616255e-35;
	}


	public static double ConvertMetersToYoctoMeters(double m){
		return m/Pow(10d, -24d);
	}


	public static double ConvertMetersToZeptoMeters(double m){
		return m/Pow(10d, -21d);
	}


	public static double ConvertMetersToAttoMeters(double m){
		return m/Pow(10d, -18d);
	}


	public static double ConvertMetersToFemtoMeters(double m){
		return m/Pow(10d, -15d);
	}


	public static double ConvertMetersToPicoMeters(double m){
		return m/Pow(10d, -12d);
	}


	public static double ConvertMetersToNanoMeters(double m){
		return m/Pow(10d, -9d);
	}


	public static double ConvertMetersToMicroMeters(double m){
		return m/Pow(10d, -6d);
	}


	public static double ConvertMetersToMilliMeters(double m){
		return m/Pow(10d, -3d);
	}


	public static double ConvertMetersToCentiMeters(double m){
		return m/Pow(10d, -2d);
	}


	public static double ConvertMetersToDeciMeters(double m){
		return m/Pow(10d, -1d);
	}


	public static double ConvertMetersToAstronomicalUnits(double m){
		return m/149597870700d;
	}


	public static double ConvertMetersToParsecs(double m){
		return m/3.0857e16;
	}


	public static double ConvertMetersToLightYears(double m){
		return m/9.4607e15;
	}


	public static double ConvertMetersToYottaMeters(double m){
		return m/Pow(10d, 24d);
	}


	public static double ConvertMetersToZettaMeters(double m){
		return m/Pow(10d, 21d);
	}


	public static double ConvertMetersToExaMeters(double m){
		return m/Pow(10d, 18d);
	}


	public static double ConvertMetersToPetaMeters(double m){
		return m/Pow(10d, 15d);
	}


	public static double ConvertMetersToTeraMeters(double m){
		return m/Pow(10d, 12d);
	}


	public static double ConvertMetersToGigaMeters(double m){
		return m/Pow(10d, 9d);
	}


	public static double ConvertMetersToMegaMeters(double m){
		return m/Pow(10d, 6d);
	}


	public static double ConvertMetersToKiloMeters(double m){
		return m/Pow(10d, 3d);
	}


	public static double ConvertMetersToHectoMeters(double m){
		return m/Pow(10d, 2d);
	}


	public static double ConvertMetersToDecaMeters(double m){
		return m/Pow(10d, 1d);
	}


	public static double ConvertMetersToRods(double m){
		return m/5.0292;
	}


	public static double ConvertMetersToLinks(double m){
		return m/0.201168;
	}


	public static double ConvertMetersToNauticalMiles(double m){
		return m/1852d;
	}


	public static double ConvertMetersToCables(double m){
		return m/185.2;
	}


	public static double ConvertMetersToFathoms(double m){
		return m/1.852;
	}


	public static double ConvertMetersToLeagues(double m){
		return m/4828.032;
	}


	public static double ConvertMetersToMiles(double m){
		return m/1609.344;
	}


	public static double ConvertMetersToFurlongs(double m){
		return m/201.168;
	}


	public static double ConvertMetersToChains(double m){
		return m/20.1168;
	}


	public static double ConvertMetersToYards(double m){
		return m/0.9144;
	}


	public static double ConvertMetersToFeet(double m){
		return m/0.3048;
	}


	public static double ConvertMetersToInches(double m){
		return m/0.0254;
	}


	public static double ConvertMetersToThous(double m){
		return m/0.0000254;
	}


	public static bool ConvertLengthToMeters(char [] to, double d, NumberReference destinationUnits){
		double y;
		bool success;

		success = true;
		y = 0d;
		if(StringsEqual(to, "meter".ToCharArray())){
			y = d;
		}else if(StringsEqual(to, "thou".ToCharArray())){
			y = ConvertThousToMeters(d);
		}else if(StringsEqual(to, "inch".ToCharArray())){
			y = ConvertInchesToMeters(d);
		}else if(StringsEqual(to, "foot".ToCharArray())){
			y = ConvertFeetToMeters(d);
		}else if(StringsEqual(to, "yard".ToCharArray())){
			y = ConvertYardsToMeters(d);
		}else if(StringsEqual(to, "chain".ToCharArray())){
			y = ConvertChainsToMeters(d);
		}else if(StringsEqual(to, "furlong".ToCharArray())){
			y = ConvertFurlongsToMeters(d);
		}else if(StringsEqual(to, "mile".ToCharArray())){
			y = ConvertMilesToMeters(d);
		}else if(StringsEqual(to, "league".ToCharArray())){
			y = ConvertLeaguesToMeters(d);
		}else if(StringsEqual(to, "fathom".ToCharArray())){
			y = ConvertFathomsToMeters(d);
		}else if(StringsEqual(to, "cable".ToCharArray())){
			y = ConvertCablesToMeters(d);
		}else if(StringsEqual(to, "nautical mile".ToCharArray())){
			y = ConvertNauticalMilesToMeters(d);
		}else if(StringsEqual(to, "link".ToCharArray())){
			y = ConvertLinksToMeters(d);
		}else if(StringsEqual(to, "rod".ToCharArray())){
			y = ConvertRodsToMeters(d);
		}else if(StringsEqual(to, "deca-meter".ToCharArray())){
			y = ConvertDecaMetersToMeters(d);
		}else if(StringsEqual(to, "hecto-meter".ToCharArray())){
			y = ConvertHectoMetersToMeters(d);
		}else if(StringsEqual(to, "kilo-meter".ToCharArray())){
			y = ConvertKiloMetersToMeters(d);
		}else if(StringsEqual(to, "mega-meter".ToCharArray())){
			y = ConvertMegaMetersToMeters(d);
		}else if(StringsEqual(to, "giga-meter".ToCharArray())){
			y = ConvertGigaMetersToMeters(d);
		}else if(StringsEqual(to, "tera-meter".ToCharArray())){
			y = ConvertTeraMetersToMeters(d);
		}else if(StringsEqual(to, "peta-meter".ToCharArray())){
			y = ConvertPetaMetersToMeters(d);
		}else if(StringsEqual(to, "exa-meter".ToCharArray())){
			y = ConvertExaMetersToMeters(d);
		}else if(StringsEqual(to, "zetta-meter".ToCharArray())){
			y = ConvertZettaMetersToMeters(d);
		}else if(StringsEqual(to, "yotta-meter".ToCharArray())){
			y = ConvertYottaMetersToMeters(d);
		}else if(StringsEqual(to, "light-year".ToCharArray())){
			y = ConvertLightYearsToMeters(d);
		}else if(StringsEqual(to, "parsec".ToCharArray())){
			y = ConvertParsecsToMeters(d);
		}else if(StringsEqual(to, "astronomical unit".ToCharArray())){
			y = ConvertAstronomicalUnitsToMeters(d);
		}else if(StringsEqual(to, "deci-meter".ToCharArray())){
			y = ConvertDeciMetersToMeters(d);
		}else if(StringsEqual(to, "centi-meter".ToCharArray())){
			y = ConvertCentiMetersToMeters(d);
		}else if(StringsEqual(to, "milli-meter".ToCharArray())){
			y = ConvertMilliMetersToMeters(d);
		}else if(StringsEqual(to, "micro-meter".ToCharArray())){
			y = ConvertMicroMetersToMeters(d);
		}else if(StringsEqual(to, "nano-meter".ToCharArray())){
			y = ConvertNanoMetersToMeters(d);
		}else if(StringsEqual(to, "pico-meter".ToCharArray())){
			y = ConvertPicoMetersToMeters(d);
		}else if(StringsEqual(to, "femto-meter".ToCharArray())){
			y = ConvertFemtoMetersToMeters(d);
		}else if(StringsEqual(to, "atto-meter".ToCharArray())){
			y = ConvertAttoMetersToMeters(d);
		}else if(StringsEqual(to, "zepto-meter".ToCharArray())){
			y = ConvertZeptoMetersToMeters(d);
		}else if(StringsEqual(to, "yocto-meter".ToCharArray())){
			y = ConvertYoctoMetersToMeters(d);
		}else if(StringsEqual(to, "planck lengths".ToCharArray())){
			y = ConvertPlanckLengthsToMeters(d);
		}else{
			success = false;
		}

		destinationUnits.numberValue = y;

		return success;
	}


	public static double ConvertPlanckLengthsToMeters(double d){
		return d*1.616255e-35;
	}


	public static double ConvertYoctoMetersToMeters(double d){
		return d*Pow(10d, -24d);
	}


	public static double ConvertZeptoMetersToMeters(double d){
		return d*Pow(10d, -21d);
	}


	public static double ConvertAttoMetersToMeters(double d){
		return d*Pow(10d, -18d);
	}


	public static double ConvertFemtoMetersToMeters(double d){
		return d*Pow(10d, -15d);
	}


	public static double ConvertPicoMetersToMeters(double d){
		return d*Pow(10d, -12d);
	}


	public static double ConvertNanoMetersToMeters(double d){
		return d*Pow(10d, -9d);
	}


	public static double ConvertMicroMetersToMeters(double d){
		return d*Pow(10d, -6d);
	}


	public static double ConvertMilliMetersToMeters(double d){
		return d*Pow(10d, -3d);
	}


	public static double ConvertCentiMetersToMeters(double d){
		return d*Pow(10d, -2d);
	}


	public static double ConvertDeciMetersToMeters(double d){
		return d*Pow(10d, -1d);
	}


	public static double ConvertAstronomicalUnitsToMeters(double d){
		return d*149597870700d;
	}


	public static double ConvertParsecsToMeters(double d){
		return d*3.0857e16;
	}


	public static double ConvertLightYearsToMeters(double d){
		return d*9.4607e15;
	}


	public static double ConvertYottaMetersToMeters(double d){
		return d*Pow(10d, 24d);
	}


	public static double ConvertZettaMetersToMeters(double d){
		return d*Pow(10d, 21d);
	}


	public static double ConvertExaMetersToMeters(double d){
		return d*Pow(10d, 18d);
	}


	public static double ConvertPetaMetersToMeters(double d){
		return d*Pow(10d, 15d);
	}


	public static double ConvertTeraMetersToMeters(double d){
		return d*Pow(10d, 12d);
	}


	public static double ConvertGigaMetersToMeters(double d){
		return d*Pow(10d, 9d);
	}


	public static double ConvertMegaMetersToMeters(double d){
		return d*Pow(10d, 6d);
	}


	public static double ConvertKiloMetersToMeters(double d){
		return d*Pow(10d, 3d);
	}


	public static double ConvertHectoMetersToMeters(double d){
		return d*Pow(10d, 2d);
	}


	public static double ConvertDecaMetersToMeters(double d){
		return d*Pow(10d, 1d);
	}


	public static double ConvertRodsToMeters(double d){
		return d*5.0292;
	}


	public static double ConvertLinksToMeters(double d){
		return d*0.201168;
	}


	public static double ConvertNauticalMilesToMeters(double d){
		return d*1852d;
	}


	public static double ConvertCablesToMeters(double d){
		return d*185.2;
	}


	public static double ConvertFathomsToMeters(double d){
		return d*1.852;
	}


	public static double ConvertLeaguesToMeters(double d){
		return d*4828.032;
	}


	public static double ConvertMilesToMeters(double d){
		return d*1609.344;
	}


	public static double ConvertFurlongsToMeters(double d){
		return d*201.168;
	}


	public static double ConvertChainsToMeters(double d){
		return d*20.1168;
	}


	public static double ConvertYardsToMeters(double d){
		return d*0.9144;
	}


	public static double ConvertFeetToMeters(double d){
		return d*0.3048;
	}


	public static double ConvertInchesToMeters(double d){
		return d*0.0254;
	}


	public static double ConvertThousToMeters(double d){
		return d*0.0000254;
	}


	public static double GramsToOunces(double g){
		return g/28.349523125;
	}


	public static double ConvertOuncesToGrams(double ounce){
		return ounce*28.349523125;
	}


	public static bool ConvertMass(char [] from, char [] to, double sourceUnits, NumberReference destinationUnits){
		bool success;

		success = ConvertMassToKg(from, sourceUnits, destinationUnits);
		if(success){
			success = ConvertMassFromKg(to, destinationUnits.numberValue, destinationUnits);
		}

		return success;
	}


	public static bool ConvertMassToKg(char [] from, double m, NumberReference destinationUnits){
		double y;
		bool success;

		success = true;
		y = 0d;
		if(StringsEqual(from, "kilogram".ToCharArray())){
			y = m;
		}else if(StringsEqual(from, "g".ToCharArray())){
			y = ConvertGramsToKilograms(m);
		}else if(StringsEqual(from, "atomic mass unit".ToCharArray())){
			y = ConvertAtomicMassUnitsToKilograms(m);
		}else if(StringsEqual(from, "planck mass".ToCharArray())){
			y = ConvertPlanckMassesToKilograms(m);
		}else if(StringsEqual(from, "solar mass".ToCharArray())){
			y = ConvertSolarMassesToKilograms(m);
		}else if(StringsEqual(from, "grain".ToCharArray())){
			y = ConvertGrainsToKilograms(m);
		}else if(StringsEqual(from, "drachm".ToCharArray())){
			y = ConvertDrachmToKilograms(m);
		}else if(StringsEqual(from, "ounce".ToCharArray())){
			y = ConvertOuncesToKilograms(m);
		}else if(StringsEqual(from, "troy ounce".ToCharArray())){
			y = ConvertTroyOuncesToKilograms(m);
		}else if(StringsEqual(from, "pound".ToCharArray())){
			y = ConvertPoundsToKilograms(m);
		}else if(StringsEqual(from, "stone".ToCharArray())){
			y = ConvertStonesToKilograms(m);
		}else if(StringsEqual(from, "quarter".ToCharArray())){
			y = ConvertQuartersToKilograms(m);
		}else if(StringsEqual(from, "hundredweight".ToCharArray())){
			y = ConvertHundredWeightsToKilograms(m);
		}else if(StringsEqual(from, "ton".ToCharArray())){
			y = ConvertTonsToKilograms(m);
		}else if(StringsEqual(from, "slug".ToCharArray())){
			y = ConvertSlugsToKilograms(m);
		}else if(StringsEqual(from, "decigram".ToCharArray())){
			y = ConvertDecigramsToKilograms(m);
		}else if(StringsEqual(from, "centigram".ToCharArray())){
			y = ConvertCentigramsToKilograms(m);
		}else if(StringsEqual(from, "milligram".ToCharArray())){
			y = ConvertMilligramsToKilograms(m);
		}else if(StringsEqual(from, "microgram".ToCharArray())){
			y = ConvertMicrogramsToKilograms(m);
		}else if(StringsEqual(from, "nanogram".ToCharArray())){
			y = ConvertNanogramsToKilograms(m);
		}else if(StringsEqual(from, "picogram".ToCharArray())){
			y = ConvertPicogramsToKilograms(m);
		}else if(StringsEqual(from, "femtogram".ToCharArray())){
			y = ConvertFemtogramsToKilograms(m);
		}else if(StringsEqual(from, "attogram".ToCharArray())){
			y = ConvertAttogramsToKilograms(m);
		}else if(StringsEqual(from, "zeptogram".ToCharArray())){
			y = ConvertZeptogramsToKilograms(m);
		}else if(StringsEqual(from, "yoctogram".ToCharArray())){
			y = ConvertYoctogramsToKilograms(m);
		}else if(StringsEqual(from, "decagram".ToCharArray())){
			y = ConvertDecagramsToKilograms(m);
		}else if(StringsEqual(from, "hectogram".ToCharArray())){
			y = ConvertHectogramsToKilograms(m);
		}else if(StringsEqual(from, "megagram".ToCharArray())){
			y = ConvertMegagramsToKilograms(m);
		}else if(StringsEqual(from, "tonne".ToCharArray())){
			y = ConvertTonneToKilograms(m);
		}else if(StringsEqual(from, "gigagram".ToCharArray())){
			y = ConvertGigagramsToKilograms(m);
		}else if(StringsEqual(from, "teragram".ToCharArray())){
			y = ConvertTeragramsToKilograms(m);
		}else if(StringsEqual(from, "petagram".ToCharArray())){
			y = ConvertPetagramsToKilograms(m);
		}else if(StringsEqual(from, "exagram".ToCharArray())){
			y = ConvertExagramsToKilograms(m);
		}else if(StringsEqual(from, "zettagram".ToCharArray())){
			y = ConvertZettagramsToKilograms(m);
		}else if(StringsEqual(from, "yottagram".ToCharArray())){
			y = ConvertYottagramsToKilograms(m);
		}else{
			success = false;
		}

		destinationUnits.numberValue = y;

		return success;
	}


	public static double ConvertYottagramsToKilograms(double m){
		return m*Pow(10d, 21d);
	}


	public static double ConvertZettagramsToKilograms(double m){
		return m*Pow(10d, 18d);
	}


	public static double ConvertExagramsToKilograms(double m){
		return m*Pow(10d, 15d);
	}


	public static double ConvertPetagramsToKilograms(double m){
		return m*Pow(10d, 12d);
	}


	public static double ConvertTeragramsToKilograms(double m){
		return m*Pow(10d, 9d);
	}


	public static double ConvertGigagramsToKilograms(double m){
		return m*Pow(10d, 6d);
	}


	public static double ConvertTonneToKilograms(double m){
		return m*Pow(10d, 3d);
	}


	public static double ConvertMegagramsToKilograms(double m){
		return m*Pow(10d, 3d);
	}


	public static double ConvertHectogramsToKilograms(double m){
		return m*Pow(10d, -2d);
	}


	public static double ConvertDecagramsToKilograms(double m){
		return m*Pow(10d, -1d);
	}


	public static double ConvertYoctogramsToKilograms(double m){
		return m*Pow(10d, -27d);
	}


	public static double ConvertZeptogramsToKilograms(double m){
		return m*Pow(10d, -24d);
	}


	public static double ConvertAttogramsToKilograms(double m){
		return m*Pow(10d, -21d);
	}


	public static double ConvertFemtogramsToKilograms(double m){
		return m*Pow(10d, -18d);
	}


	public static double ConvertPicogramsToKilograms(double m){
		return m*Pow(10d, -15d);
	}


	public static double ConvertNanogramsToKilograms(double m){
		return m*Pow(10d, -12d);
	}


	public static double ConvertMicrogramsToKilograms(double m){
		return m*Pow(10d, -9d);
	}


	public static double ConvertMilligramsToKilograms(double m){
		return m*Pow(10d, -6d);
	}


	public static double ConvertCentigramsToKilograms(double m){
		return m*Pow(10d, -5d);
	}


	public static double ConvertDecigramsToKilograms(double m){
		return m*Pow(10d, -4d);
	}


	public static double ConvertSlugsToKilograms(double m){
		return m*14.59390;
	}


	public static double ConvertTonsToKilograms(double m){
		return m*1016.0469088;
	}


	public static double ConvertHundredWeightsToKilograms(double m){
		return m*50.80234544;
	}


	public static double ConvertQuartersToKilograms(double m){
		return m*12.70058636;
	}


	public static double ConvertStonesToKilograms(double m){
		return m*6.35029318;
	}


	public static double ConvertPoundsToKilograms(double m){
		return m*0.45359237;
	}


	public static double ConvertTroyOuncesToKilograms(double m){
		return m*(31.1034768/1000d);
	}


	public static double ConvertOuncesToKilograms(double m){
		return m*(28.349523125/1000d);
	}


	public static double ConvertDrachmToKilograms(double m){
		return m*(1.7718451953125/1000d);
	}


	public static double ConvertGrainsToKilograms(double m){
		return m*(0.06479891/1000d);
	}


	public static double ConvertSolarMassesToKilograms(double m){
		return m*1.98847e30;
	}


	public static double ConvertPlanckMassesToKilograms(double m){
		return m*2.176435e-8;
	}


	public static double ConvertAtomicMassUnitsToKilograms(double m){
		return m*1.66053906660e-27;
	}


	public static double ConvertGramsToKilograms(double m){
		return m*0.001;
	}


	public static bool ConvertMassFromKg(char [] from, double m, NumberReference destinationUnits){
		double y;
		bool success;

		success = true;
		y = 0d;
		if(StringsEqual(from, "kilogram".ToCharArray())){
			y = m;
		}else if(StringsEqual(from, "g".ToCharArray())){
			y = ConvertKilogramsToGrams(m);
		}else if(StringsEqual(from, "atomic mass unit".ToCharArray())){
			y = ConvertKilogramsToAtomicMassUnits(m);
		}else if(StringsEqual(from, "planck mass".ToCharArray())){
			y = ConvertKilogramsToPlanckMasses(m);
		}else if(StringsEqual(from, "solar mass".ToCharArray())){
			y = ConvertKilogramsToSolarMasses(m);
		}else if(StringsEqual(from, "grain".ToCharArray())){
			y = ConvertKilogramsToGrains(m);
		}else if(StringsEqual(from, "drachm".ToCharArray())){
			y = ConvertKilogramsToDrachm(m);
		}else if(StringsEqual(from, "ounce".ToCharArray())){
			y = ConvertKilogramsToOunces(m);
		}else if(StringsEqual(from, "troy ounce".ToCharArray())){
			y = ConvertKilogramsToTroyOunces(m);
		}else if(StringsEqual(from, "pound".ToCharArray())){
			y = ConvertKilogramsToPounds(m);
		}else if(StringsEqual(from, "stone".ToCharArray())){
			y = ConvertKilogramsToStones(m);
		}else if(StringsEqual(from, "quarter".ToCharArray())){
			y = ConvertKilogramsToQuarters(m);
		}else if(StringsEqual(from, "hundredweight".ToCharArray())){
			y = ConvertKilogramsToHundredWeights(m);
		}else if(StringsEqual(from, "ton".ToCharArray())){
			y = ConvertKilogramsToTons(m);
		}else if(StringsEqual(from, "slug".ToCharArray())){
			y = ConvertKilogramsToSlugs(m);
		}else if(StringsEqual(from, "decigram".ToCharArray())){
			y = ConvertKilogramsToDecigrams(m);
		}else if(StringsEqual(from, "centigram".ToCharArray())){
			y = ConvertKilogramsToCentigrams(m);
		}else if(StringsEqual(from, "milligram".ToCharArray())){
			y = ConvertKilogramsToMilligrams(m);
		}else if(StringsEqual(from, "microgram".ToCharArray())){
			y = ConvertKilogramsToMicrograms(m);
		}else if(StringsEqual(from, "nanogram".ToCharArray())){
			y = ConvertKilogramsToNanograms(m);
		}else if(StringsEqual(from, "picogram".ToCharArray())){
			y = ConvertKilogramsToPicograms(m);
		}else if(StringsEqual(from, "femtogram".ToCharArray())){
			y = ConvertKilogramsToFemtograms(m);
		}else if(StringsEqual(from, "attogram".ToCharArray())){
			y = ConvertKilogramsToAttograms(m);
		}else if(StringsEqual(from, "zeptogram".ToCharArray())){
			y = ConvertKilogramsToZeptograms(m);
		}else if(StringsEqual(from, "yoctogram".ToCharArray())){
			y = ConvertKilogramsToYoctograms(m);
		}else if(StringsEqual(from, "decagram".ToCharArray())){
			y = ConvertKilogramsToDecagrams(m);
		}else if(StringsEqual(from, "hectogram".ToCharArray())){
			y = ConvertKilogramsToHectograms(m);
		}else if(StringsEqual(from, "megagram".ToCharArray())){
			y = ConvertKilogramsToMegagrams(m);
		}else if(StringsEqual(from, "tonne".ToCharArray())){
			y = ConvertKilogramsToTonne(m);
		}else if(StringsEqual(from, "gigagram".ToCharArray())){
			y = ConvertKilogramsToGigagrams(m);
		}else if(StringsEqual(from, "teragram".ToCharArray())){
			y = ConvertKilogramsToTeragrams(m);
		}else if(StringsEqual(from, "petagram".ToCharArray())){
			y = ConvertKilogramsToPetagrams(m);
		}else if(StringsEqual(from, "exagram".ToCharArray())){
			y = ConvertKilogramsToExagrams(m);
		}else if(StringsEqual(from, "zettagram".ToCharArray())){
			y = ConvertKilogramsToZettagrams(m);
		}else if(StringsEqual(from, "yottagram".ToCharArray())){
			y = ConvertKilogramsToYottagrams(m);
		}else{
			success = false;
		}

		destinationUnits.numberValue = y;

		return success;
	}


	public static double ConvertKilogramsToYottagrams(double m){
		return m/Pow(10d, 21d);
	}


	public static double ConvertKilogramsToZettagrams(double m){
		return m/Pow(10d, 18d);
	}


	public static double ConvertKilogramsToExagrams(double m){
		return m/Pow(10d, 15d);
	}


	public static double ConvertKilogramsToPetagrams(double m){
		return m/Pow(10d, 12d);
	}


	public static double ConvertKilogramsToTeragrams(double m){
		return m/Pow(10d, 9d);
	}


	public static double ConvertKilogramsToGigagrams(double m){
		return m/Pow(10d, 6d);
	}


	public static double ConvertKilogramsToTonne(double m){
		return m/Pow(10d, 3d);
	}


	public static double ConvertKilogramsToMegagrams(double m){
		return m/Pow(10d, 3d);
	}


	public static double ConvertKilogramsToHectograms(double m){
		return m/Pow(10d, -1d);
	}


	public static double ConvertKilogramsToDecagrams(double m){
		return m/Pow(10d, -2d);
	}


	public static double ConvertKilogramsToYoctograms(double m){
		return m/Pow(10d, -27d);
	}


	public static double ConvertKilogramsToZeptograms(double m){
		return m/Pow(10d, -24d);
	}


	public static double ConvertKilogramsToAttograms(double m){
		return m/Pow(10d, -21d);
	}


	public static double ConvertKilogramsToFemtograms(double m){
		return m/Pow(10d, -18d);
	}


	public static double ConvertKilogramsToPicograms(double m){
		return m/Pow(10d, -15d);
	}


	public static double ConvertKilogramsToNanograms(double m){
		return m/Pow(10d, -12d);
	}


	public static double ConvertKilogramsToMicrograms(double m){
		return m/Pow(10d, -9d);
	}


	public static double ConvertKilogramsToMilligrams(double m){
		return m/Pow(10d, -6d);
	}


	public static double ConvertKilogramsToCentigrams(double m){
		return m/Pow(10d, -5d);
	}


	public static double ConvertKilogramsToDecigrams(double m){
		return m/Pow(10d, -4d);
	}


	public static double ConvertKilogramsToSlugs(double m){
		return m/14.59390;
	}


	public static double ConvertKilogramsToTons(double m){
		return m/1016.0469088;
	}


	public static double ConvertKilogramsToHundredWeights(double m){
		return m/50.80234544;
	}


	public static double ConvertKilogramsToQuarters(double m){
		return m/12.70058636;
	}


	public static double ConvertKilogramsToStones(double m){
		return m/6.35029318;
	}


	public static double ConvertKilogramsToPounds(double m){
		return m/0.45359237;
	}


	public static double ConvertKilogramsToTroyOunces(double m){
		return m/(31.1034768/1000d);
	}


	public static double ConvertKilogramsToOunces(double m){
		return m/(28.349523125/1000d);
	}


	public static double ConvertKilogramsToDrachm(double m){
		return m/(1.7718451953125/1000d);
	}


	public static double ConvertKilogramsToGrains(double m){
		return m/(0.06479891/1000d);
	}


	public static double ConvertKilogramsToSolarMasses(double m){
		return m/1.98847e30;
	}


	public static double ConvertKilogramsToPlanckMasses(double m){
		return m/2.176435e-8;
	}


	public static double ConvertKilogramsToAtomicMassUnits(double m){
		return m/1.66053906660e-27;
	}


	public static double ConvertKilogramsToGrams(double m){
		return m/0.001;
	}


	public static double AddDecibells(double db1, double db2){
		return 10d*Log10(Pow(10d, db1/10d) + Pow(10d, db2/10d));
	}


	public static double SubtractDecibells(double db1, double db2){
		return 10d*Log10(Pow(10d, db1/10d) - Pow(10d, db2/10d));
	}


	public static double MultiplyDecibellsWithScalar(double db, double scalar){
		return 10d*Log10(Pow(10d, db/10d)*scalar);
	}


	public static double DivideDecibellsWithScalar(double db, double scalar){
		return 10d*Log10(Pow(10d, db/10d)/scalar);
	}


	public static double [] StringToNumberArray(char [] stringx){
		double i;
		double [] array;

		array = new double [(int)(stringx.Length)];

		for(i = 0d; i < stringx.Length; i = i + 1d){
			array[(int)(i)] = stringx[(int)(i)];
		}
		return array;
	}


	public static char [] NumberArrayToString(double [] array){
		double i;
		char [] stringx;

		stringx = new char [(int)(array.Length)];

		for(i = 0d; i < array.Length; i = i + 1d){
			stringx[(int)(i)] = (char)(array[(int)(i)]);
		}
		return stringx;
	}


	public static bool NumberArraysEqual(double [] a, double [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool BooleanArraysEqual(bool [] a, bool [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool StringsEqual(char [] a, char [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static void FillNumberArray(double [] a, double value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillString(char [] a, char value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillBooleanArray(bool [] a, bool value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static bool FillNumberArrayRange(double [] a, double value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillBooleanArrayRange(bool [] a, bool value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillStringRange(char [] a, char value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static double [] CopyNumberArray(double [] a){
		double i;
		double [] n;

		n = new double [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool [] CopyBooleanArray(bool [] a){
		double i;
		bool [] n;

		n = new bool [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static char [] CopyString(char [] a){
		double i;
		char [] n;

		n = new char [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool CopyNumberArrayRange(double [] a, double from, double to, NumberArrayReference copyReference){
		double i, length;
		double [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new double [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.numberArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyBooleanArrayRange(bool [] a, double from, double to, BooleanArrayReference copyReference){
		double i, length;
		bool [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new bool [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.booleanArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyStringRange(char [] a, double from, double to, StringReference copyReference){
		double i, length;
		char [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new char [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.stringx = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool IsLastElement(double length, double index){
		return index + 1d == length;
	}


	public static double [] CreateNumberArray(double length, double value){
		double [] array;

		array = new double [(int)(length)];
		FillNumberArray(array, value);

		return array;
	}


	public static bool [] CreateBooleanArray(double length, bool value){
		bool [] array;

		array = new bool [(int)(length)];
		FillBooleanArray(array, value);

		return array;
	}


	public static char [] CreateString(double length, char value){
		char [] array;

		array = new char [(int)(length)];
		FillString(array, value);

		return array;
	}


	public static void SwapElementsOfNumberArray(double [] A, double ai, double bi){
		double tmp;

		tmp = A[(int)(ai)];
		A[(int)(ai)] = A[(int)(bi)];
		A[(int)(bi)] = tmp;
	}


	public static void SwapElementsOfStringArray(StringArrayReference A, double ai, double bi){
		StringReference tmp;

		tmp = A.stringArray[(int)(ai)];
		A.stringArray[(int)(ai)] = A.stringArray[(int)(bi)];
		A.stringArray[(int)(bi)] = tmp;
	}


	public static BooleanReference CreateBooleanReference(bool value){
		BooleanReference refx;
		refx = new BooleanReference();
		refx.booleanValue = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReference(bool [] value){
		BooleanArrayReference refx;
		refx = new BooleanArrayReference();
		refx.booleanArray = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReferenceLengthValue(double length, bool value){
		BooleanArrayReference refx;
		double i;
		refx = new BooleanArrayReference();
		refx.booleanArray = new bool [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.booleanArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeBooleanArrayReference(BooleanArrayReference booleanArrayReference){
		delete(booleanArrayReference.booleanArray);
		delete(booleanArrayReference);
	}


	public static CharacterReference CreateCharacterReference(char value){
		CharacterReference refx;
		refx = new CharacterReference();
		refx.characterValue = value;

		return refx;
	}


	public static NumberReference CreateNumberReference(double value){
		NumberReference refx;
		refx = new NumberReference();
		refx.numberValue = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReference(double [] value){
		NumberArrayReference refx;
		refx = new NumberArrayReference();
		refx.numberArray = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReferenceLengthValue(double length, double value){
		NumberArrayReference refx;
		double i;
		refx = new NumberArrayReference();
		refx.numberArray = new double [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.numberArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeNumberArrayReference(NumberArrayReference numberArrayReference){
		delete(numberArrayReference.numberArray);
		delete(numberArrayReference);
	}


	public static StringReference CreateStringReference(char [] value){
		StringReference refx;
		refx = new StringReference();
		refx.stringx = value;

		return refx;
	}


	public static StringReference CreateStringReferenceLengthValue(double length, char value){
		StringReference refx;
		double i;
		refx = new StringReference();
		refx.stringx = new char [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringx[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeStringReference(StringReference stringReference){
		delete(stringReference.stringx);
		delete(stringReference);
	}


	public static StringArrayReference CreateStringArrayReference(StringReference [] strings){
		StringArrayReference refx;
		refx = new StringArrayReference();
		refx.stringArray = strings;

		return refx;
	}


	public static StringArrayReference CreateStringArrayReferenceLengthValue(double length, char [] value){
		StringArrayReference refx;
		double i;
		refx = new StringArrayReference();
		refx.stringArray = new StringReference [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringArray[(int)(i)] = CreateStringReference(value);
		}

		return refx;
	}


	public static void FreeStringArrayReference(StringArrayReference stringArrayReference){
		double i;
		for(i = 0d; i < stringArrayReference.stringArray.Length; i = i + 1d){
			delete(stringArrayReference.stringArray[(int)(i)]);
		}
		delete(stringArrayReference.stringArray);
		delete(stringArrayReference);
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}